
#include <algorithm>
#include <iostream>
#include <vector>

#include "mod_deih.h"

std::vector<int> count;
std::vector<std::string> names;

void dump() {
  std::vector<std::string>::iterator
    it = names.begin();
  std::vector<int>::iterator
    jt = count.begin();

  for (; it != names.end(); ++it, ++jt)
    std::cout << *it << ":" << *jt
              << std::endl;

  std::cout << std::endl;
}

void insert( std::string n ) {

  std::vector<std::string>::iterator
    it = lower_bound( names.begin(),
                      names.end(), n );

  if (it == names.end()) {
    names.insert( it, n );
    count.insert( count.end(), 1 );
  } else {
    if (*it != n) {
      count.insert( count.begin() +
                    (it - names.begin()),
                    1 );
      names.insert( it, n );
    } else {
      ++(*( count.begin() +
            (it - names.begin()) ));
    }
  }
}

void remove( int i ) {
  if (--count[i] == 0) {
    names.erase( names.begin() + i );
    count.erase( count.begin() + i );
  }
}

std::string get( int i ) {
  return names[i];
}

