
#include <algorithm>
#include <iostream>
#include <string>
#include <vector>

std::vector<std::string> names;

void dump() {
  std::vector<std::string>::iterator
    it = names.begin();

  for (; it != names.end(); ++it)
    std::cout << *it << std::endl;

  std::cout << std::endl;
}

void insert( std::string n ) {

  std::vector<std::string>
    ::iterator it =
      lower_bound( names.begin(),
                   names.end(), n );

  if (it == names.end() || *it != n)
    names.insert( it, n );
}

void remove( int i ) {
  names.erase( names.begin() + i );
}

std::string get( int i ) {
  return names[i];
}

#include <iostream>

int main() {

  insert( "Berger" );
  insert( "Schulz" );
  insert( "Neumann" );
  insert( "Meyer" );
  insert( "Wernersen" );
  insert( "Neumann" );

  dump();

  remove( 1 );
  insert( "Mayer" );

  dump();
  
  names[2] = "Naumann";

  dump();

  return 0;
}
